# SoVRMLPixelTexture Class Reference
[VRML97 classes]

`#include <Inventor/VRMLnodes/SoVRMLPixelTexture.h>`

Inheritance diagram for SoVRMLPixelTexture:

List of all members.

## Detailed Description

The SoVRMLPixelTexture class is used for mapping a texture image onto geometry..

The detailed class documentation is taken verbatim from the VRML97 standard (ISO/IEC 14772-1:1997). It is copyright The Web3D Consortium, and is used by permission of the Consortium:

      PixelTexture {
        exposedField SFImage  image      0 0 0    # see SoSFImage
        field        SFBool   repeatS    TRUE
        field        SFBool   repeatT    TRUE
      }

The PixelTexture node defines a 2D image-based texture map as an explicit array of pixel values (image field) and parameters controlling tiling repetition of the texture onto geometry. Texture maps are defined in a 2D coordinate system (s, t) that ranges from 0.0 to 1.0 in both directions. The bottom edge of the pixel image corresponds to the S-axis of the texture map, and left edge of the pixel image corresponds to the T-axis of the texture map. The lower-left pixel of the pixel image corresponds to s=0.0, t=0.0, and the top-right pixel of the image corresponds to s = 1.0, t = 1.0. See 4.6.11, Texture maps (<http://www.web3d.org/technicalinfo/specifications/vrml97/part1/concepts.html#4.6.11>), for a general description of texture maps. Figure 6.13 depicts an example PixelTexture.

Figure 6.13 -- PixelTexture node

See 4.14, Lighting model (<http://www.web3d.org/technicalinfo/specifications/vrml97/part1/concepts.html#4.14>), for a description of how the texture values interact with the appearance of the geometry. SoSFImage, describes the specification of an image. The repeatS and repeatT fields specify how the texture wraps in the S and T directions. If repeatS is TRUE (the default), the texture map is repeated outside the 0-to-1 texture coordinate range in the S direction so that it fills the shape. If repeatS is FALSE, the texture coordinates are clamped in the S direction to lie within the 0.0 to 1.0 range. The repeatT field is analogous to the repeatS field.

## Public Member Functions

| SoVRMLPixelTexture (void)
virtual void | doAction (SoAction *action)
virtual void | GLRender (SoGLRenderAction *action)
virtual void | callback (SoCallbackAction *action)
virtual void | rayPick (SoRayPickAction *action)

## Static Public Member Functions

void | initClass (void)

## Public Attributes

SoSFImage | image

## Protected Member Functions

virtual | ~SoVRMLPixelTexture ()
virtual SbBool | readInstance (SoInput *in, unsigned short flags)
virtual void | notify (SoNotList *list)

## Constructor & Destructor Documentation

SoVRMLPixelTexture::SoVRMLPixelTexture | ( | void |  | ) |

| Constructor.

SoVRMLPixelTexture::~SoVRMLPixelTexture | ( |  | ) | `[protected, virtual]`

| Destructor.

## Member Function Documentation

void SoVRMLPixelTexture::initClass | ( | void |  | ) | `[static]`

| Sets up initialization for data common to all instances of this class, like submitting necessary information to the Coin type system. Reimplemented from SoVRMLTexture.

void SoVRMLPixelTexture::doAction | ( | SoAction * | action | ) | `[virtual]`

| This function performs the typical operation of a node for any action. Reimplemented from SoNode.

void SoVRMLPixelTexture::GLRender | ( | SoGLRenderAction * | action | ) | `[virtual]`

| Action method for the SoGLRenderAction. This is called during rendering traversals. Nodes influencing the rendering state in any way or who wants to throw geometry primitives at OpenGL overrides this method. Reimplemented from SoVRMLTexture.

void SoVRMLPixelTexture::callback | ( | SoCallbackAction * | action | ) | `[virtual]`

| Action method for SoCallbackAction. Simply updates the state according to how the node behaves for the render action, so the application programmer can use the SoCallbackAction for extracting information about the scene graph. Reimplemented from SoNode.

void SoVRMLPixelTexture::rayPick | ( | SoRayPickAction * | action | ) | `[virtual]`

| Action method for SoRayPickAction. Checks the ray specification of the action and tests for intersection with the data of the node. Nodes influencing relevant state variables for how picking is done also overrides this method. Reimplemented from SoNode.

SbBool SoVRMLPixelTexture::readInstance | ( | SoInput * | in,
|  | unsigned short | flags
| ) | `[protected, virtual]`

This method is mainly intended for internal use during file import operations.

It reads a definition of an instance from the input stream in. The input stream state points to the start of a serialized / persistant representation of an instance of this class type.

`TRUE` or `FALSE` is returned, depending on if the instantiation and configuration of the new object of this class type went ok or not. The import process should be robust and handle corrupted input streams by returning `FALSE`.

flags is used internally during binary import when reading user extension nodes, group nodes or engines.

Reimplemented from SoNode.

void SoVRMLPixelTexture::notify | ( | SoNotList * | list | ) | `[protected, virtual]`

| Overloaded to detect when fields change. Reimplemented from SoNode.

The documentation for this class was generated from the following files:

- SoVRMLPixelTexture.h
- PixelTexture.cpp